JUCE: ComponentPeer Class Reference

JUCE

Classes | Public Types | Public Member Functions | Static Public Member Functions | Static Protected Member Functions | Protected Attributes | Static Protected Attributes | List of all members
ComponentPeer Class Referenceabstract
juce_gui_basics » windows

The Component class uses a ComponentPeer internally to create and manage a real operating-system window. More...

`#include <juce_ComponentPeer.h>`

Inheritance diagram for ComponentPeer:

## Classes
struct | DragInfo
| Structure to describe drag and drop information. More...
class | OptionalBorderSize
| Represents the window borders around a window component. More...
struct | ScaleFactorListener
| Used to receive callbacks when the OS scale factor of this ComponentPeer changes. More...

## Public Types
enum | StyleFlags { windowAppearsOnTaskbar = (1 << 0) , windowIsTemporary = (1 << 1) , windowIgnoresMouseClicks = (1 << 2) , windowHasTitleBar = (1 << 3) , windowIsResizable = (1 << 4) , windowHasMinimiseButton = (1 << 5) , windowHasMaximiseButton = (1 << 6) , windowHasCloseButton = (1 << 7) , windowHasDropShadow = (1 << 8) , windowRepaintedExplictly = (1 << 9) , windowIgnoresKeyPresses = (1 << 10) , windowRequiresSynchronousCoreGraphicsRendering = (1 << 11) , windowIsSemiTransparent = (1 << 30) }
| A combination of these flags is passed to the ComponentPeer constructor. More...
enum class | Style { automatic , light , dark }

## Public Member Functions
| ComponentPeer (Component &component, int styleFlags)
| Creates a peer. More...
| ~ComponentPeer () override
| Destructor. More...
Component & | getComponent () noexcept
| Returns the component being represented by this peer. More...
int | getStyleFlags () const noexcept
| Returns the set of style flags that were set when the window was created. More...
uint32 | getUniqueID () const noexcept
| Returns a unique ID for this peer. More...
virtual void * | getNativeHandle () const =0
| Returns the raw handle to whatever kind of window is being used. More...
virtual void | setVisible (bool shouldBeVisible)=0
| Shows or hides the window. More...
virtual void | setTitle (const String &title)=0
| Changes the title of the window. More...
virtual bool | setDocumentEditedStatus (bool edited)
| If this type of window is capable of indicating that the document in it has been edited, then this changes its status. More...
virtual void | setRepresentedFile (const File &)
| If this type of window is capable of indicating that it represents a file, then this lets you set the file. More...
virtual void | setBounds (const Rectangle< int > &newBounds, bool isNowFullScreen)=0
| Moves and resizes the window. More...
void | updateBounds ()
| Updates the peer's bounds to match its component. More...
virtual Rectangle< int > | getBounds () const =0
| Returns the current position and size of the window. More...
virtual Point< float > | localToGlobal (Point< float > relativePosition)=0
| Converts a position relative to the top-left of this component to screen coordinates. More...
virtual Point< float > | globalToLocal (Point< float > screenPosition)=0
| Converts a screen coordinate to a position relative to the top-left of this component. More...
Point< int > | localToGlobal (Point< int > relativePosition)
| Converts a position relative to the top-left of this component to screen coordinates. More...
Point< int > | globalToLocal (Point< int > screenPosition)
| Converts a screen coordinate to a position relative to the top-left of this component. More...
virtual Rectangle< int > | localToGlobal (const Rectangle< int > &relativePosition)
| Converts a rectangle relative to the top-left of this component to screen coordinates. More...
virtual Rectangle< int > | globalToLocal (const Rectangle< int > &screenPosition)
| Converts a screen area to a position relative to the top-left of this component. More...
Rectangle< float > | localToGlobal (const Rectangle< float > &relativePosition)
| Converts a rectangle relative to the top-left of this component to screen coordinates. More...
Rectangle< float > | globalToLocal (const Rectangle< float > &screenPosition)
| Converts a screen area to a position relative to the top-left of this component. More...
Rectangle< int > | getAreaCoveredBy (const Component &subComponent) const
| Returns the area in peer coordinates that is covered by the given sub-comp (which may be at any depth) More...
virtual void | setMinimised (bool shouldBeMinimised)=0
| Minimises the window. More...
virtual bool | isMinimised () const =0
| True if the window is currently minimised. More...
virtual void | setFullScreen (bool shouldBeFullScreen)=0
| Enable/disable fullscreen mode for the window. More...
virtual bool | isFullScreen () const =0
| True if the window is currently full-screen. More...
virtual bool | isKioskMode () const
| True if the window is in kiosk-mode. More...
void | setNonFullScreenBounds (const Rectangle< int > &newBounds) noexcept
| Sets the size to restore to if fullscreen mode is turned off. More...
const Rectangle< int > & | getNonFullScreenBounds () const noexcept
| Returns the size to restore to if fullscreen mode is turned off. More...
virtual void | setIcon (const Image &newIcon)=0
| Attempts to change the icon associated with this window. More...
void | setConstrainer (ComponentBoundsConstrainer *newConstrainer) noexcept
| Sets a constrainer to use if the peer can resize itself. More...
ComponentBoundsConstrainer * | getConstrainer () const noexcept
| Returns the current constrainer, if one has been set. More...
virtual bool | contains (Point< int > localPos, bool trueIfInAChildWindow) const =0
| Checks if a point is in the window. More...
virtual OptionalBorderSize | getFrameSizeIfPresent () const =0
| Returns the size of the window frame that's around this window. More...
virtual BorderSize< int > | getFrameSize () const =0
| Returns the size of the window frame that's around this window. More...
void | handleMovedOrResized ()
| This is called when the window's bounds change. More...
virtual void | handleScreenSizeChange ()
| This is called if the screen resolution changes. More...
void | handlePaint (LowLevelGraphicsContext &contextToPaintTo)
| This is called to repaint the component into the given context. More...
virtual bool | setAlwaysOnTop (bool alwaysOnTop)=0
| Sets this window to either be always-on-top or normal. More...
virtual void | toFront (bool takeKeyboardFocus)=0
| Brings the window to the top, optionally also giving it keyboard focus. More...
virtual void | toBehind (ComponentPeer *other)=0
| Moves the window to be just behind another one. More...
void | handleBroughtToFront ()
| Called when the window is brought to the front, either by the OS or by a call to toFront(). More...
virtual bool | isFocused () const =0
| True if the window has the keyboard focus. More...
virtual void | grabFocus ()=0
| Tries to give the window keyboard focus. More...
void | handleFocusGain ()
| Called when the window gains keyboard focus. More...
void | handleFocusLoss ()
| Called when the window loses keyboard focus. More...
Component * | getLastFocusedSubcomponent () const noexcept
bool | handleKeyPress (int keyCode, juce_wchar textCharacter)
| Called when a key is pressed. More...
bool | handleKeyPress (const KeyPress &key)
| Called when a key is pressed. More...
bool | handleKeyUpOrDown (bool isKeyDown)
| Called whenever a key is pressed or released. More...
void | handleModifierKeysChange ()
| Called whenever a modifier key is pressed or released. More...
virtual void | closeInputMethodContext ()
| If there's a currently active input-method context - i.e. More...
void | refreshTextInputTarget ()
| Alerts the peer that the current text input target has changed somehow. More...
TextInputTarget * | findCurrentTextInputTarget ()
| Returns the currently focused TextInputTarget, or null if none is found. More...
virtual void | repaint (const Rectangle< int > &area)=0
| Invalidates a region of the window to be repainted asynchronously. More...
virtual void | performAnyPendingRepaintsNow ()=0
| This can be called (from the message thread) to cause the immediate redrawing of any areas of this window that need repainting. More...
virtual void | setAlpha (float newAlpha)=0
| Changes the window's transparency. More...
void | handleMouseEvent (MouseInputSource::InputSourceType type, Point< float > positionWithinPeer, ModifierKeys newMods, float pressure, float orientation, int64 time, PenDetails pen={}, int touchIndex=0)
void | handleMouseWheel (MouseInputSource::InputSourceType type, Point< float > positionWithinPeer, int64 time, const MouseWheelDetails &, int touchIndex=0)
void | handleMagnifyGesture (MouseInputSource::InputSourceType type, Point< float > positionWithinPeer, int64 time, float scaleFactor, int touchIndex=0)
void | handleUserClosingWindow ()
bool | handleDragMove (const DragInfo &)
bool | handleDragExit (const DragInfo &)
bool | handleDragDrop (const DragInfo &)
virtual StringArray | getAvailableRenderingEngines ()=0
virtual int | getCurrentRenderingEngine () const
virtual void | setCurrentRenderingEngine (int index)
void | addScaleFactorListener (ScaleFactorListener *listenerToAdd)
| Adds a scale factor listener. More...
void | removeScaleFactorListener (ScaleFactorListener *listenerToRemove)
| Removes a scale factor listener. More...
virtual double | getPlatformScaleFactor () const noexcept
| On Windows and Linux this will return the OS scaling factor currently being applied to the native window. More...
virtual void | setHasChangedSinceSaved (bool)
| On platforms that support it, this will update the window's titlebar in some way to indicate that the window's document needs saving. More...
void | setAppStyle (Style s)
| On operating systems that support it, this will update the style of this peer as requested. More...
Style | getAppStyle () const
| Returns the style requested for this app. More...

## Static Public Member Functions
static int | getNumPeers () noexcept
| Returns the number of currently-active peers. More...
static ComponentPeer * | getPeer (int index) noexcept
| Returns one of the currently-active peers. More...
static ComponentPeer * | getPeerFor (const Component *) noexcept
| Returns the peer that's attached to the given component, or nullptr if there isn't one. More...
static bool | isValidPeer (const ComponentPeer *peer) noexcept
| Checks if this peer object is valid. More...
static ModifierKeys | getCurrentModifiersRealtime () noexcept
| On desktop platforms this method will check all the mouse and key states and return a ModifierKeys object representing them. More...

## Static Protected Member Functions
static void | forceDisplayUpdate ()

## Protected Attributes
Component & | component
const int | styleFlags
Rectangle< int > | lastNonFullscreenBounds
ComponentBoundsConstrainer * | constrainer = nullptr
ListenerList< ScaleFactorListener > | scaleFactorListeners
Style | style = Style::automatic

## Static Protected Attributes
static std::function< ModifierKeys()> | getNativeRealtimeModifiers

## Detailed Description

The Component class uses a ComponentPeer internally to create and manage a real operating-system window.

This is an abstract base class - the platform specific code contains implementations of it for the various platforms.

User-code should very rarely need to have any involvement with this class.

See also
  Component::createNewPeer

## Member Enumeration Documentation

## ◆ StyleFlags

enum ComponentPeer::StyleFlags

A combination of these flags is passed to the ComponentPeer constructor.

Enumerator
windowAppearsOnTaskbar | Indicates that the window should have a corresponding entry on the taskbar (ignored on MacOSX)
windowIsTemporary | Indicates that the window is a temporary popup, like a menu, tooltip, etc.
windowIgnoresMouseClicks | Indicates that the window should let mouse clicks pass through it (may not be possible on some platforms).
windowHasTitleBar | Indicates that the window should have a normal OS-specific title bar and frame. if not specified, the window will be borderless.
windowIsResizable | Indicates that the window should have a resizable border.
windowHasMinimiseButton | Indicates that if the window has a title bar, it should have a minimise button on it.
windowHasMaximiseButton | Indicates that if the window has a title bar, it should have a maximise button on it.
windowHasCloseButton | Indicates that if the window has a title bar, it should have a close button on it.
windowHasDropShadow | Indicates that the window should have a drop-shadow (this may not be possible on all platforms).
windowRepaintedExplictly | Not intended for public use - this tells a window not to do its own repainting, but only to repaint when the performAnyPendingRepaintsNow() method is called.
windowIgnoresKeyPresses | Tells the window not to catch any keypresses. This can be used for things like plugin windows, to stop them interfering with the host's shortcut keys.
windowRequiresSynchronousCoreGraphicsRendering | Indicates that the window should not be rendered with asynchronous Core Graphics drawing operations. Use this if there are issues with regions not being redrawn at the expected time (macOS and iOS only).
windowIsSemiTransparent | Not intended for public use - makes a window transparent.

## ◆ Style

enum class ComponentPeer::Style
| strong

Enumerator
automatic | A style that matches the system-wide style.
light | A light style, which will probably use dark text on a light background.
dark | A dark style, which will probably use light text on a dark background.

## Constructor & Destructor Documentation

## ◆ ComponentPeer()

ComponentPeer::ComponentPeer | ( | Component & | component,
|  | int | styleFlags
| ) |  |

Creates a peer.

The component is the one that we intend to represent, and the style flags are a combination of the values in the StyleFlags enum

## ◆ ~ComponentPeer()

ComponentPeer::~ComponentPeer | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ getComponent()

Component & ComponentPeer::getComponent | ( |  | ) |
| noexcept

Returns the component being represented by this peer.

## ◆ getStyleFlags()

int ComponentPeer::getStyleFlags | ( |  | ) | const
| noexcept

Returns the set of style flags that were set when the window was created.

See also
  Component::addToDesktop

## ◆ getUniqueID()

uint32 ComponentPeer::getUniqueID | ( |  | ) | const
| noexcept

Returns a unique ID for this peer.

Each peer that is created is given a different ID.

## ◆ getNativeHandle()

virtual void * ComponentPeer::getNativeHandle | ( |  | ) | const
| pure virtual

Returns the raw handle to whatever kind of window is being used.

On windows, this is probably a HWND, on the mac, it's likely to be a WindowRef, but remember there's no guarantees what you'll get back.

## ◆ setVisible()

virtual void ComponentPeer::setVisible | ( | bool | shouldBeVisible | ) |
| pure virtual

Shows or hides the window.

## ◆ setTitle()

virtual void ComponentPeer::setTitle | ( | const String & | title | ) |
| pure virtual

Changes the title of the window.

## ◆ setDocumentEditedStatus()

virtual bool ComponentPeer::setDocumentEditedStatus | ( | bool | edited | ) |
| virtual

If this type of window is capable of indicating that the document in it has been edited, then this changes its status.

For example in OSX, this changes the appearance of the close button.

Returns
  true if the window has a mechanism for showing this, or false if not.

## ◆ setRepresentedFile()

virtual void ComponentPeer::setRepresentedFile | ( | const File & |  | ) |
| virtual

If this type of window is capable of indicating that it represents a file, then this lets you set the file.

E.g. in OSX it'll show an icon for the file in the title bar.

## ◆ setBounds()

virtual void ComponentPeer::setBounds | ( | const Rectangle< int > & | newBounds,
|  | bool | isNowFullScreen
| ) |  |
| pure virtual

Moves and resizes the window.

If the native window is contained in another window, then the coordinates are relative to the parent window's origin, not the screen origin.

This should result in a callback to handleMovedOrResized().

## ◆ updateBounds()

void ComponentPeer::updateBounds | ( |  | ) |

Updates the peer's bounds to match its component.

## ◆ getBounds()

virtual Rectangle< int > ComponentPeer::getBounds | ( |  | ) | const
| pure virtual

Returns the current position and size of the window.

If the native window is contained in another window, then the coordinates are relative to the parent window's origin, not the screen origin.

## ◆ localToGlobal() [1/4]

virtual Point< float > ComponentPeer::localToGlobal | ( | Point< float > | relativePosition | ) |
| pure virtual

Converts a position relative to the top-left of this component to screen coordinates.

## ◆ globalToLocal() [1/4]

virtual Point< float > ComponentPeer::globalToLocal | ( | Point< float > | screenPosition | ) |
| pure virtual

Converts a screen coordinate to a position relative to the top-left of this component.

## ◆ localToGlobal() [2/4]

Point< int > ComponentPeer::localToGlobal | ( | Point< int > | relativePosition | ) |

Converts a position relative to the top-left of this component to screen coordinates.

## ◆ globalToLocal() [2/4]

Point< int > ComponentPeer::globalToLocal | ( | Point< int > | screenPosition | ) |

Converts a screen coordinate to a position relative to the top-left of this component.

## ◆ localToGlobal() [3/4]

virtual Rectangle< int > ComponentPeer::localToGlobal | ( | const Rectangle< int > & | relativePosition | ) |
| virtual

Converts a rectangle relative to the top-left of this component to screen coordinates.

## ◆ globalToLocal() [3/4]

virtual Rectangle< int > ComponentPeer::globalToLocal | ( | const Rectangle< int > & | screenPosition | ) |
| virtual

Converts a screen area to a position relative to the top-left of this component.

## ◆ localToGlobal() [4/4]

Rectangle< float > ComponentPeer::localToGlobal | ( | const Rectangle< float > & | relativePosition | ) |

Converts a rectangle relative to the top-left of this component to screen coordinates.

## ◆ globalToLocal() [4/4]

Rectangle< float > ComponentPeer::globalToLocal | ( | const Rectangle< float > & | screenPosition | ) |

Converts a screen area to a position relative to the top-left of this component.

## ◆ getAreaCoveredBy()

Rectangle< int > ComponentPeer::getAreaCoveredBy | ( | const Component & | subComponent | ) | const

Returns the area in peer coordinates that is covered by the given sub-comp (which may be at any depth)

## ◆ setMinimised()

virtual void ComponentPeer::setMinimised | ( | bool | shouldBeMinimised | ) |
| pure virtual

Minimises the window.

## ◆ isMinimised()

virtual bool ComponentPeer::isMinimised | ( |  | ) | const
| pure virtual

True if the window is currently minimised.

## ◆ setFullScreen()

virtual void ComponentPeer::setFullScreen | ( | bool | shouldBeFullScreen | ) |
| pure virtual

Enable/disable fullscreen mode for the window.

## ◆ isFullScreen()

virtual bool ComponentPeer::isFullScreen | ( |  | ) | const
| pure virtual

True if the window is currently full-screen.

## ◆ isKioskMode()

virtual bool ComponentPeer::isKioskMode | ( |  | ) | const
| virtual

True if the window is in kiosk-mode.

## ◆ setNonFullScreenBounds()

void ComponentPeer::setNonFullScreenBounds | ( | const Rectangle< int > & | newBounds | ) |
| noexcept

Sets the size to restore to if fullscreen mode is turned off.

## ◆ getNonFullScreenBounds()

const Rectangle< int > & ComponentPeer::getNonFullScreenBounds | ( |  | ) | const
| noexcept

Returns the size to restore to if fullscreen mode is turned off.

## ◆ setIcon()

virtual void ComponentPeer::setIcon | ( | const Image & | newIcon | ) |
| pure virtual

Attempts to change the icon associated with this window.

## ◆ setConstrainer()

void ComponentPeer::setConstrainer | ( | ComponentBoundsConstrainer * | newConstrainer | ) |
| noexcept

Sets a constrainer to use if the peer can resize itself.

The constrainer won't be deleted by this object, so the caller must manage its lifetime.

## ◆ getConstrainer()

ComponentBoundsConstrainer * ComponentPeer::getConstrainer | ( |  | ) | const
| noexcept

Returns the current constrainer, if one has been set.

## ◆ contains()

virtual bool ComponentPeer::contains | ( | Point< int > | localPos,
|  | bool | trueIfInAChildWindow
| ) |  | const
| pure virtual

Checks if a point is in the window.

The position is relative to the top-left of this window, in unscaled peer coordinates. If trueIfInAChildWindow is false, then this returns false if the point is actually inside a child of this window.

## ◆ getFrameSizeIfPresent()

virtual OptionalBorderSize ComponentPeer::getFrameSizeIfPresent | ( |  | ) | const
| pure virtual

Returns the size of the window frame that's around this window.

Depending on the platform the border size may be invalid for a short transient after creating a new window. Hence the returned value must be checked using operator bool() and the contained value can be accessed using operator*() only if it is present.

Whether or not the window has a normal window frame depends on the flags that were set when the window was created by Component::addToDesktop()

## ◆ getFrameSize()

virtual BorderSize< int > ComponentPeer::getFrameSize | ( |  | ) | const
| pure virtual

Returns the size of the window frame that's around this window.

Whether or not the window has a normal window frame depends on the flags that were set when the window was created by Component::addToDesktop()

## ◆ handleMovedOrResized()

void ComponentPeer::handleMovedOrResized | ( |  | ) |

This is called when the window's bounds change.

A peer implementation must call this when the window is moved and resized, so that this method can pass the message on to the component.

## ◆ handleScreenSizeChange()

virtual void ComponentPeer::handleScreenSizeChange | ( |  | ) |
| virtual

This is called if the screen resolution changes.

A peer implementation must call this if the monitor arrangement changes or the available screen size changes.

## ◆ handlePaint()

void ComponentPeer::handlePaint | ( | LowLevelGraphicsContext & | contextToPaintTo | ) |

This is called to repaint the component into the given context.

## ◆ setAlwaysOnTop()

virtual bool ComponentPeer::setAlwaysOnTop | ( | bool | alwaysOnTop | ) |
| pure virtual

Sets this window to either be always-on-top or normal.

Some kinds of window might not be able to do this, so should return false.

## ◆ toFront()

virtual void ComponentPeer::toFront | ( | bool | takeKeyboardFocus | ) |
| pure virtual

Brings the window to the top, optionally also giving it keyboard focus.

## ◆ toBehind()

virtual void ComponentPeer::toBehind | ( | ComponentPeer * | other | ) |
| pure virtual

Moves the window to be just behind another one.

## ◆ handleBroughtToFront()

void ComponentPeer::handleBroughtToFront | ( |  | ) |

Called when the window is brought to the front, either by the OS or by a call to toFront().

## ◆ isFocused()

virtual bool ComponentPeer::isFocused | ( |  | ) | const
| pure virtual

True if the window has the keyboard focus.

## ◆ grabFocus()

virtual void ComponentPeer::grabFocus | ( |  | ) |
| pure virtual

Tries to give the window keyboard focus.

## ◆ handleFocusGain()

void ComponentPeer::handleFocusGain | ( |  | ) |

Called when the window gains keyboard focus.

## ◆ handleFocusLoss()

void ComponentPeer::handleFocusLoss | ( |  | ) |

Called when the window loses keyboard focus.

## ◆ getLastFocusedSubcomponent()

Component * ComponentPeer::getLastFocusedSubcomponent | ( |  | ) | const
| noexcept

## ◆ handleKeyPress() [1/2]

bool ComponentPeer::handleKeyPress | ( | int | keyCode,
|  | juce_wchar | textCharacter
| ) |  |

Called when a key is pressed.

For keycode info, see the KeyPress class. Returns true if the keystroke was used.

## ◆ handleKeyPress() [2/2]

bool ComponentPeer::handleKeyPress | ( | const KeyPress & | key | ) |

Called when a key is pressed.

Returns true if the keystroke was used.

## ◆ handleKeyUpOrDown()

bool ComponentPeer::handleKeyUpOrDown | ( | bool | isKeyDown | ) |

Called whenever a key is pressed or released.

Returns true if the keystroke was used.

## ◆ handleModifierKeysChange()

void ComponentPeer::handleModifierKeysChange | ( |  | ) |

Called whenever a modifier key is pressed or released.

## ◆ closeInputMethodContext()

virtual void ComponentPeer::closeInputMethodContext | ( |  | ) |
| virtual

If there's a currently active input-method context - i.e.

characters are being composed using multiple keystrokes - this should commit the current state of the context to the text and clear the context. This should not hide the virtual keyboard.

## ◆ refreshTextInputTarget()

void ComponentPeer::refreshTextInputTarget | ( |  | ) |

Alerts the peer that the current text input target has changed somehow.

The peer may hide or show the virtual keyboard as a result of this call.

## ◆ findCurrentTextInputTarget()

TextInputTarget * ComponentPeer::findCurrentTextInputTarget | ( |  | ) |

Returns the currently focused TextInputTarget, or null if none is found.

## ◆ repaint()

virtual void ComponentPeer::repaint | ( | const Rectangle< int > & | area | ) |
| pure virtual

Invalidates a region of the window to be repainted asynchronously.

## ◆ performAnyPendingRepaintsNow()

virtual void ComponentPeer::performAnyPendingRepaintsNow | ( |  | ) |
| pure virtual

This can be called (from the message thread) to cause the immediate redrawing of any areas of this window that need repainting.

You shouldn't ever really need to use this, it's mainly for special purposes like supporting audio plugins where the host's event loop is out of our control.

## ◆ setAlpha()

virtual void ComponentPeer::setAlpha | ( | float | newAlpha | ) |
| pure virtual

Changes the window's transparency.

## ◆ handleMouseEvent()

void ComponentPeer::handleMouseEvent | ( | MouseInputSource::InputSourceType | type,
|  | Point< float > | positionWithinPeer,
|  | ModifierKeys | newMods,
|  | float | pressure,
|  | float | orientation,
|  | int64 | time,
|  | PenDetails | pen = `{}`,
|  | int | touchIndex = `0`
| ) |  |

## ◆ handleMouseWheel()

void ComponentPeer::handleMouseWheel | ( | MouseInputSource::InputSourceType | type,
|  | Point< float > | positionWithinPeer,
|  | int64 | time,
|  | const MouseWheelDetails & | ,
|  | int | touchIndex = `0`
| ) |  |

## ◆ handleMagnifyGesture()

void ComponentPeer::handleMagnifyGesture | ( | MouseInputSource::InputSourceType | type,
|  | Point< float > | positionWithinPeer,
|  | int64 | time,
|  | float | scaleFactor,
|  | int | touchIndex = `0`
| ) |  |

## ◆ handleUserClosingWindow()

void ComponentPeer::handleUserClosingWindow | ( |  | ) |

## ◆ handleDragMove()

bool ComponentPeer::handleDragMove | ( | const DragInfo & |  | ) |

## ◆ handleDragExit()

bool ComponentPeer::handleDragExit | ( | const DragInfo & |  | ) |

## ◆ handleDragDrop()

bool ComponentPeer::handleDragDrop | ( | const DragInfo & |  | ) |

## ◆ getNumPeers()

static int ComponentPeer::getNumPeers | ( |  | ) |
| staticnoexcept

Returns the number of currently-active peers.

See also
  getPeer

## ◆ getPeer()

static ComponentPeer * ComponentPeer::getPeer | ( | int | index | ) |
| staticnoexcept

Returns one of the currently-active peers.

See also
  getNumPeers

## ◆ getPeerFor()

static ComponentPeer * ComponentPeer::getPeerFor | ( | const Component * |  | ) |
| staticnoexcept

Returns the peer that's attached to the given component, or nullptr if there isn't one.

## ◆ isValidPeer()

static bool ComponentPeer::isValidPeer | ( | const ComponentPeer * | peer | ) |
| staticnoexcept

Checks if this peer object is valid.

See also
  getNumPeers

## ◆ getAvailableRenderingEngines()

virtual StringArray ComponentPeer::getAvailableRenderingEngines | ( |  | ) |
| pure virtual

## ◆ getCurrentRenderingEngine()

virtual int ComponentPeer::getCurrentRenderingEngine | ( |  | ) | const
| virtual

## ◆ setCurrentRenderingEngine()

virtual void ComponentPeer::setCurrentRenderingEngine | ( | int | index | ) |
| virtual

## ◆ getCurrentModifiersRealtime()

static ModifierKeys ComponentPeer::getCurrentModifiersRealtime | ( |  | ) |
| staticnoexcept

On desktop platforms this method will check all the mouse and key states and return a ModifierKeys object representing them.

This isn't recommended and is only needed in special circumstances for up-to-date modifier information at times when the app's event loop isn't running normally.

Another reason to avoid this method is that it's not stateless and calling it may update the ModifierKeys::currentModifiers object, which could cause subtle changes in the behaviour of some components.

## ◆ addScaleFactorListener()

void ComponentPeer::addScaleFactorListener | ( | ScaleFactorListener * | listenerToAdd | ) |

Adds a scale factor listener.

## ◆ removeScaleFactorListener()

void ComponentPeer::removeScaleFactorListener | ( | ScaleFactorListener * | listenerToRemove | ) |

Removes a scale factor listener.

## ◆ getPlatformScaleFactor()

virtual double ComponentPeer::getPlatformScaleFactor | ( |  | ) | const
| virtualnoexcept

On Windows and Linux this will return the OS scaling factor currently being applied to the native window.

This is used to convert between physical and logical pixels at the OS API level and you shouldn't need to use it in your own code unless you are dealing directly with the native window.

## ◆ setHasChangedSinceSaved()

virtual void ComponentPeer::setHasChangedSinceSaved | ( | bool |  | ) |
| virtual

On platforms that support it, this will update the window's titlebar in some way to indicate that the window's document needs saving.

## ◆ setAppStyle()

void ComponentPeer::setAppStyle | ( | Style | s | ) |

On operating systems that support it, this will update the style of this peer as requested.

Note that this will not update the theme system-wide. This will only update UI elements so that they display appropriately for this peer!

References gl::s.

## ◆ getAppStyle()

Style ComponentPeer::getAppStyle | ( |  | ) | const

Returns the style requested for this app.

## ◆ forceDisplayUpdate()

static void ComponentPeer::forceDisplayUpdate | ( |  | ) |
| staticprotected

## Member Data Documentation

## ◆ component

Component& ComponentPeer::component
| protected

## ◆ styleFlags

const int ComponentPeer::styleFlags
| protected

## ◆ lastNonFullscreenBounds

Rectangle<int> ComponentPeer::lastNonFullscreenBounds
| protected

## ◆ constrainer

ComponentBoundsConstrainer* ComponentPeer::constrainer = nullptr
| protected

## ◆ getNativeRealtimeModifiers

std::function<ModifierKeys()> ComponentPeer::getNativeRealtimeModifiers
| staticprotected

## ◆ scaleFactorListeners

ListenerList<ScaleFactorListener> ComponentPeer::scaleFactorListeners
| protected

## ◆ style

Style ComponentPeer::style = Style::automatic
| protected

The documentation for this class was generated from the following file:

- juce_ComponentPeer.h